// Code generated by goa v3.12.3, DO NOT EDIT.
//
// login HTTP client encoders and decoders
//
// Command:
// $ goa gen gitlab.eclipse.org/eclipse/xfsc/tsa/login/design

package client

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"

	login "gitlab.eclipse.org/eclipse/xfsc/tsa/login/gen/login"
	goahttp "goa.design/goa/v3/http"
)

// BuildLoginRequest instantiates a HTTP request object with method and path
// set to call the "login" service "Login" endpoint
func (c *Client) BuildLoginRequest(ctx context.Context, v any) (*http.Request, error) {
	u := &url.URL{Scheme: c.scheme, Host: c.host, Path: LoginLoginPath()}
	req, err := http.NewRequest("POST", u.String(), nil)
	if err != nil {
		return nil, goahttp.ErrInvalidURL("login", "Login", u.String(), err)
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}

	return req, nil
}

// EncodeLoginRequest returns an encoder for requests sent to the login Login
// server.
func EncodeLoginRequest(encoder func(*http.Request) goahttp.Encoder) func(*http.Request, any) error {
	return func(req *http.Request, v any) error {
		p, ok := v.(*login.LoginRequest)
		if !ok {
			return goahttp.ErrInvalidType("login", "Login", "*login.LoginRequest", v)
		}
		body := NewLoginRequestBody(p)
		if err := encoder(req).Encode(&body); err != nil {
			return goahttp.ErrEncodingError("login", "Login", err)
		}
		return nil
	}
}

// DecodeLoginResponse returns a decoder for responses returned by the login
// Login endpoint. restoreBody controls whether the response body should be
// restored after having been read.
func DecodeLoginResponse(decoder func(*http.Response) goahttp.Decoder, restoreBody bool) func(*http.Response) (any, error) {
	return func(resp *http.Response) (any, error) {
		if restoreBody {
			b, err := io.ReadAll(resp.Body)
			if err != nil {
				return nil, err
			}
			resp.Body = io.NopCloser(bytes.NewBuffer(b))
			defer func() {
				resp.Body = io.NopCloser(bytes.NewBuffer(b))
			}()
		} else {
			defer resp.Body.Close()
		}
		switch resp.StatusCode {
		case http.StatusOK:
			var (
				body LoginResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("login", "Login", err)
			}
			err = ValidateLoginResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("login", "Login", err)
			}
			res := NewLoginResultOK(&body)
			return res, nil
		default:
			body, _ := io.ReadAll(resp.Body)
			return nil, goahttp.ErrInvalidResponse("login", "Login", resp.StatusCode, string(body))
		}
	}
}

// BuildLoginInvitationRequest instantiates a HTTP request object with method
// and path set to call the "login" service "LoginInvitation" endpoint
func (c *Client) BuildLoginInvitationRequest(ctx context.Context, v any) (*http.Request, error) {
	u := &url.URL{Scheme: c.scheme, Host: c.host, Path: LoginInvitationLoginPath()}
	req, err := http.NewRequest("GET", u.String(), nil)
	if err != nil {
		return nil, goahttp.ErrInvalidURL("login", "LoginInvitation", u.String(), err)
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}

	return req, nil
}

// DecodeLoginInvitationResponse returns a decoder for responses returned by
// the login LoginInvitation endpoint. restoreBody controls whether the
// response body should be restored after having been read.
func DecodeLoginInvitationResponse(decoder func(*http.Response) goahttp.Decoder, restoreBody bool) func(*http.Response) (any, error) {
	return func(resp *http.Response) (any, error) {
		if restoreBody {
			b, err := io.ReadAll(resp.Body)
			if err != nil {
				return nil, err
			}
			resp.Body = io.NopCloser(bytes.NewBuffer(b))
			defer func() {
				resp.Body = io.NopCloser(bytes.NewBuffer(b))
			}()
		} else {
			defer resp.Body.Close()
		}
		switch resp.StatusCode {
		case http.StatusOK:
			var (
				body LoginInvitationResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("login", "LoginInvitation", err)
			}
			err = ValidateLoginInvitationResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("login", "LoginInvitation", err)
			}
			res := NewLoginInvitationResultOK(&body)
			return res, nil
		default:
			body, _ := io.ReadAll(resp.Body)
			return nil, goahttp.ErrInvalidResponse("login", "LoginInvitation", resp.StatusCode, string(body))
		}
	}
}

// BuildLoginWithVCRequest instantiates a HTTP request object with method and
// path set to call the "login" service "LoginWithVC" endpoint
func (c *Client) BuildLoginWithVCRequest(ctx context.Context, v any) (*http.Request, error) {
	u := &url.URL{Scheme: c.scheme, Host: c.host, Path: LoginWithVCLoginPath()}
	req, err := http.NewRequest("POST", u.String(), nil)
	if err != nil {
		return nil, goahttp.ErrInvalidURL("login", "LoginWithVC", u.String(), err)
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}

	return req, nil
}

// EncodeLoginWithVCRequest returns an encoder for requests sent to the login
// LoginWithVC server.
func EncodeLoginWithVCRequest(encoder func(*http.Request) goahttp.Encoder) func(*http.Request, any) error {
	return func(req *http.Request, v any) error {
		p, ok := v.(*login.LoginVCRequest)
		if !ok {
			return goahttp.ErrInvalidType("login", "LoginWithVC", "*login.LoginVCRequest", v)
		}
		body := NewLoginWithVCRequestBody(p)
		if err := encoder(req).Encode(&body); err != nil {
			return goahttp.ErrEncodingError("login", "LoginWithVC", err)
		}
		return nil
	}
}

// DecodeLoginWithVCResponse returns a decoder for responses returned by the
// login LoginWithVC endpoint. restoreBody controls whether the response body
// should be restored after having been read.
func DecodeLoginWithVCResponse(decoder func(*http.Response) goahttp.Decoder, restoreBody bool) func(*http.Response) (any, error) {
	return func(resp *http.Response) (any, error) {
		if restoreBody {
			b, err := io.ReadAll(resp.Body)
			if err != nil {
				return nil, err
			}
			resp.Body = io.NopCloser(bytes.NewBuffer(b))
			defer func() {
				resp.Body = io.NopCloser(bytes.NewBuffer(b))
			}()
		} else {
			defer resp.Body.Close()
		}
		switch resp.StatusCode {
		case http.StatusOK:
			var (
				body LoginWithVCResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("login", "LoginWithVC", err)
			}
			err = ValidateLoginWithVCResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("login", "LoginWithVC", err)
			}
			res := NewLoginWithVCLoginVCResultOK(&body)
			return res, nil
		default:
			body, _ := io.ReadAll(resp.Body)
			return nil, goahttp.ErrInvalidResponse("login", "LoginWithVC", resp.StatusCode, string(body))
		}
	}
}

// BuildKeysRequest instantiates a HTTP request object with method and path set
// to call the "login" service "Keys" endpoint
func (c *Client) BuildKeysRequest(ctx context.Context, v any) (*http.Request, error) {
	u := &url.URL{Scheme: c.scheme, Host: c.host, Path: KeysLoginPath()}
	req, err := http.NewRequest("GET", u.String(), nil)
	if err != nil {
		return nil, goahttp.ErrInvalidURL("login", "Keys", u.String(), err)
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}

	return req, nil
}

// DecodeKeysResponse returns a decoder for responses returned by the login
// Keys endpoint. restoreBody controls whether the response body should be
// restored after having been read.
func DecodeKeysResponse(decoder func(*http.Response) goahttp.Decoder, restoreBody bool) func(*http.Response) (any, error) {
	return func(resp *http.Response) (any, error) {
		if restoreBody {
			b, err := io.ReadAll(resp.Body)
			if err != nil {
				return nil, err
			}
			resp.Body = io.NopCloser(bytes.NewBuffer(b))
			defer func() {
				resp.Body = io.NopCloser(bytes.NewBuffer(b))
			}()
		} else {
			defer resp.Body.Close()
		}
		switch resp.StatusCode {
		case http.StatusOK:
			var (
				body KeysResponseBody
				err  error
			)
			err = decoder(resp).Decode(&body)
			if err != nil {
				return nil, goahttp.ErrDecodingError("login", "Keys", err)
			}
			err = ValidateKeysResponseBody(&body)
			if err != nil {
				return nil, goahttp.ErrValidationError("login", "Keys", err)
			}
			res := NewKeysResultOK(&body)
			return res, nil
		default:
			body, _ := io.ReadAll(resp.Body)
			return nil, goahttp.ErrInvalidResponse("login", "Keys", resp.StatusCode, string(body))
		}
	}
}
